## stress-ng-0.17.02.tar.gz

=== Makefile ===
#
# Copyright (C) 2013-2021 Canonical, Ltd.
# Copyright (C) 2021-2023 Colin Ian King
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#

VERSION=0.17.02
#
# Codename "omniferous optimized overreacher"
#

KERNEL=$(shell uname -s)
NODENAME=$(shell uname -n)

override CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -std=gnu99 -g

#
#  Building stress-vnni with less than -O2 causes breakage with
#  gcc-13.2, so remove then and ensure at least -O2 is used or
#  honour flags > -O2 if they are provided
#
VNNI_OFLAGS_REMOVE=-O0 -O1 -Og
VNNI_CFLAGS += $(filter-out $(VNNI_OFLAGS_REMOVE),$(CFLAGS))

#
# Default -O2 if optimization level not defined
#
ifeq "$(findstring -O,$(CFLAGS))" ""
	override CFLAGS += -O2
endif
ifeq "$(findstring -O,$(VNNI_CFLAGS))" ""
	override VNNI_CFLAGS += -O2
endif

#
# Pedantic flags
#
ifeq ($(PEDANTIC),1)
override CFLAGS += -Wcast-qual -Wfloat-equal -Wmissing-declarations \
	-Wmissing-format-attribute -Wno-long-long -Wpacked \
	-Wredundant-decls -Wshadow -Wno-missing-field-initializers \
	-Wno-missing-braces -Wno-sign-compare -Wno-multichar \
	-DHAVE_PEDANTIC
endif

#
# Test for hardening flags and apply them if applicable
#
MACHINE = $(shell uname -m)
ifneq ($(PRESERVE_CFLAGS),1)
ifneq ($(MACHINE),$(filter $(MACHINE),alpha parisc ia64))
ifeq ($(shell $(CC) $(CFLAGS) -fstack-protector-strong -E -xc /dev/null > /dev/null 2>& 1 && echo 1),1)
override CFLAGS += -fstack-protector-strong
endif
endif
ifeq ($(shell $(CC) $(CFLAGS) -Werror=format-security -E -xc /dev/null > /dev/null 2>& 1 && echo 1),1)
override CFLAGS += -Werror=format-security
endif
ifneq ($(findstring pcc,$(CC)),pcc)
ifeq ($(shell $(CC) $(CFLAGS) -D_FORTIFY_SOURCE=2 -E -xc /dev/null > /dev/null 2>& 1 && echo 1),1)
override CFLAGS += -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2
endif
endif
endif

#
# Expected build warnings
#
ifeq ($(UNEXPECTED),1)
override CFLAGS += -DCHECK_UNEXPECTED
endif

#
# Disable any user defined PREFV setting
#
ifneq ($(PRE_V),)
override undefine PRE_V
endif
#
# Verbosity prefixes
#
ifeq ($(VERBOSE),)
PRE_V=@
PRE_Q=@
else
PRE_V=
PRE_Q=@#
endif

ifneq ($(PRESERVE_CFLAGS),1)
ifeq ($(findstring icc,$(CC)),icc)
override CFLAGS += -no-inline-max-size -no-inline-max-total-size
override CFLAGS += -axAVX,CORE-AVX2,CORE-AVX-I,CORE-AVX512,SSE2,SSE3,SSSE3,SSE4.1,SSE4.2,SANDYBRIDGE,SKYLAKE,SKYLAKE-AVX512,TIGERLAKE,SAPPHIRERAPIDS
override CFLAGS += -ip -falign-loops -funroll-loops -ansi-alias -fma -qoverride-limits
endif
endif

#ifeq ($(findstring clang,$(CC)),clang)
#override CFLAGS += -Weverything
#endif

GREP = grep
#
# SunOS requires special grep for -e support
#
ifeq ($(KERNEL),SunOS)
ifneq ($(NODENAME),dilos)
GREP = /usr/xpg4/bin/grep
endif
endif

#
# Static flags, only to be used when using GCC
#
ifeq ($(STATIC),1)
override LDFLAGS += -static -z muldefs
override CFLAGS += -DBUILD_STATIC
endif

BINDIR=/usr/bin
MANDIR=/usr/share/man/man1
JOBDIR=/usr/share/stress-ng/example-jobs
BASHDIR=/usr/share/bash-completion/completions


#
# Header files
#
HEADERS = \
	core-arch.h \
	core-affinity.h \
	core-asm-arm.h \
	core-asm-generic.h \
	core-asm-ppc64.h \
	core-asm-riscv.h \
	core-asm-s390.h \
	core-asm-sparc.h \
	core-asm-x86.h \
	core-asm-ret.h \
	core-attribute.h \
	core-bitops.h \
	core-builtin.h \
	core-capabilities.h \
	core-clocksource.h \
	core-config-check.h \
	core-cpu.h \
	core-cpu-cache.h \
	core-cpuidle.h \
	core-ftrace.h \
	core-hash.h \
	core-ignite-cpu.h \
	core-interrupts.h \
	core-io-priority.h \
	core-job.h \
	core-helper.h \
	core-killpid.h \
	core-klog.h \
	core-limit.h \
	core-lock.h \
	core-log.h \
	core-madvise.h \
	core-mlock.h \
	core-mmap.h \
	core-mincore.h \
	core-module.h \
	core-mounts.h \
	core-mwc.h \
	core-nt-load.h \
	core-nt-store.h \
	core-net.h \
	core-numa.h \
	core-opts.h \
	core-out-of-memory.h \
	core-parse-opts.h \
	core-perf.h \
	core-pragma.h \
	core-processes.h \
	core-pthread.h \
	core-put.h \
	core-resources.h \
	core-sched.h \
	core-setting.h \
	core-shared-heap.h \
	core-shim.h \
	core-smart.h \
	core-sort.h \
	core-stressors.h \
	core-syslog.h \
	core-target-clones.h \
	core-thermal-zone.h \
	core-thrash.h \
	core-time.h \
	core-try-open.h \
	core-vecmath.h \
	core-version.h \
	core-vmstat.h \
	stress-af-alg-defconfigs.h \
	stress-eigen-ops.h \
	stress-ng.h

#
#  Build time generated header files
#
HEADERS_GEN = \
	config.h \
	git-commit-id.h \
	io-uring.h \
	personality.h

#
#  Stressors
#
STRESS_SRC = \
	stress-access.c \
	stress-affinity.c \
	stress-af-alg.c \
	stress-aio.c \
	stress-aiol.c \
	stress-alarm.c \
	stress-apparmor.c \
	stress-atomic.c \
	stress-bad-altstack.c \
	stress-bad-ioctl.c \
	stress-bigheap.c \
	stress-bind-mount.c \
	stress-binderfs.c \
	stress-branch.c \
	stress-brk.c \
	stress-bsearch.c \
	stress-cache.c \
	stress-cacheline.c \
	stress-cap.c \
	stress-cgroup.c \
	stress-chattr.c \
	stress-chdir.c \
	stress-chmod.c \
	stress-chown.c \
	stress-chroot.c \
	stress-clock.c \
	stress-clone.c \
	stress-close.c \
	stress-context.c \
	stress-copy-file.c \
	stress-cpu.c \
	stress-cpu-online.c \
	stress-crypt.c \
	stress-cyclic.c \
	stress-daemon.c \
	stress-dccp.c \
	stress-dekker.c \
	stress-dentry.c \
	stress-dev.c \
	stress-dev-shm.c \
	stress-dir.c \
	stress-dirdeep.c \
	stress-dirmany.c \
	stress-dnotify.c \
	stress-dup.c \
	stress-dynlib.c \
	stress-eigen.c \
	stress-efivar.c \
	stress-enosys.c \
	stress-env.c \
	stress-epoll.c \
	stress-eventfd.c \
	stress-exec.c \
	stress-exit-group.c \
	stress-fallocate.c \
	stress-fanotify.c \
	stress-far-branch.c \
	stress-fault.c \
	stress-fcntl.c \
	stress-file-ioctl.c \
	stress-fiemap.c \
	stress-fifo.c \
	stress-filename.c \
	stress-flock.c \
	stress-flushcache.c \
	stress-fma.c \
	stress-fork.c \
	stress-forkheavy.c \
	stress-fp.c \
	stress-fp-error.c \
	stress-fpunch.c \
	stress-fsize.c \
	stress-fstat.c \
	stress-full.c \
	stress-funccall.c \
	stress-funcret.c \
	stress-futex.c \
	stress-get.c \
	stress-getrandom.c \
	stress-getdent.c \
	stress-goto.c \
	stress-gpu.c \
	stress-handle.c \
	stress-hash.c \
	stress-hdd.c \
	stress-heapsort.c \
	stress-hrtimers.c \
	stress-hsearch.c \
	stress-icache.c \
	stress-icmp-flood.c \
	stress-idle-page.c \
	stress-inode-flags.c \
	stress-inotify.c \
	stress-io.c \
	stress-iomix.c \
	stress-ioport.c \
	stress-ioprio.c \
	stress-io-uring.c \
	stress-ipsec-mb.c \
	stress-itimer.c \
	stress-jpeg.c \
	stress-judy.c \
	stress-kcmp.c \
	stress-key.c \
	stress-kill.c \
	stress-klog.c \
	stress-kvm.c \
	stress-l1cache.c \
	stress-landlock.c \
	stress-lease.c \
	stress-led.c \
	stress-link.c \
	stress-list.c \
	stress-llc-affinity.c \
	stress-loadavg.c \
	stress-lockbus.c \
	stress-locka.c \
	stress-lockf.c \
	stress-lockofd.c \
	stress-longjmp.c \
	stress-loop.c \
	stress-lsearch.c \
	stress-madvise.c \
	stress-malloc.c \
	stress-matrix.c \
	stress-matrix-3d.c \
	stress-mcontend.c \
	stress-membarrier.c \
	stress-memcpy.c \
	stress-memfd.c \
	stress-memhotplug.c \
	stress-memrate.c \
	stress-memthrash.c \
	stress-mergesort.c \
	stress-metamix.c \
	stress-mincore.c \
	stress-misaligned.c \
	stress-mknod.c \
	stress-mlock.c \
	stress-mlockmany.c \
	stress-mmap.c \
	stress-mmapaddr.c \
	stress-mmapfixed.c \
	stress-mmapfork.c \
	stress-mmaphuge.c \
	stress-mmapmany.c \
	stress-module.c \
	stress-mprotect.c \
	stress-mpfr.c \
	stress-mq.c \
	stress-mremap.c \
	stress-msg.c \
	stress-msync.c \
	stress-msyncmany.c \
	stress-munmap.c \
	stress-mutex.c \
	stress-nanosleep.c \
	stress-netdev.c \
	stress-netlink-proc.c \
	stress-netlink-task.c \
	stress-nice.c \
	stress-nop.c \
	stress-null.c \
	stress-numa.c \
	stress-oom-pipe.c \
	stress-opcode.c \
	stress-open.c \
	stress-pagemove.c \
	stress-pageswap.c \
	stress-pci.c \
	stress-personality.c \
	stress-peterson.c \
	stress-physpage.c \
	stress-pidfd.c \
	stress-ping-sock.c \
	stress-pipe.c \
	stress-pipeherd.c \
	stress-pkey.c \
	stress-plugin.c \
	stress-poll.c \
	stress-prctl.c \
	stress-prefetch.c \
	stress-priv-instr.c \
	stress-procfs.c \
	stress-pthread.c \
	stress-ptrace.c \
	stress-pty.c \
	stress-quota.c \
	stress-qsort.c \
	stress-race-sched.c \
	stress-radixsort.c \
	stress-randlist.c \
	stress-ramfs.c \
	stress-rawdev.c \
	stress-rawpkt.c \
	stress-rawsock.c \
	stress-rawudp.c \
	stress-rdrand.c \
	stress-readahead.c \
	stress-reboot.c \
	stress-regs.c \
	stress-remap.c \
	stress-rename.c \
	stress-resched.c \
	stress-resources.c \
	stress-revio.c \
	stress-ring-pipe.c \
	stress-rlimit.c \
	stress-rmap.c \
	stress-rotate.c \
	stress-rseq.c \
	stress-rtc.c \
	stress-sctp.c \
	stress-schedmix.c \
	stress-schedpolicy.c \
	stress-seal.c \
	stress-seccomp.c \
	stress-secretmem.c \
	stress-seek.c \
	stress-sem.c \
	stress-sem-sysv.c \
	stress-sendfile.c \
	stress-session.c \
	stress-set.c \
	stress-shellsort.c \
	stress-shm.c \
	stress-shm-sysv.c \
	stress-sigabrt.c \
	stress-sigbus.c \
	stress-sigchld.c \
	stress-sigfd.c \
	stress-sigfpe.c \
	stress-sigio.c \
	stress-signal.c \
	stress-signest.c \
	stress-sigpending.c \
	stress-sigpipe.c \
	stress-sigq.c \
	stress-sigrt.c \
	stress-sigsegv.c \
	stress-sigsuspend.c \
	stress-sigtrap.c \
	stress-sigxcpu.c \
	stress-sigxfsz.c \
	stress-skiplist.c \
	stress-sleep.c \
	stress-smi.c \
	stress-sock.c \
	stress-sockabuse.c \
	stress-sockdiag.c \
	stress-sockfd.c \
	stress-sockpair.c \
	stress-sockmany.c \
	stress-softlockup.c \
	stress-spawn.c \
	stress-sparsematrix.c \
	stress-splice.c \
	stress-stack.c \
	stress-stackmmap.c \
	stress-str.c \
	stress-stream.c \
	stress-swap.c \
	stress-switch.c \
	stress-sync-file.c \
	stress-syncload.c \
	stress-sysbadaddr.c \
	stress-syscall.c \
	stress-sysinfo.c \
	stress-sysinval.c \
	stress-sysfs.c \
	stress-tee.c \
	stress-timer.c \
	stress-timerfd.c \
	stress-tlb-shootdown.c \
	stress-tmpfs.c \
	stress-touch.c \
	stress-tree.c \
	stress-trig.c \
	stress-tsc.c \
	stress-tsearch.c \
	stress-tun.c \
	stress-udp.c \
	stress-udp-flood.c \
	stress-umount.c \
	stress-unshare.c \
	stress-uprobe.c \
	stress-urandom.c \
	stress-userfaultfd.c \
	stress-usersyscall.c \
	stress-utime.c \
	stress-vdso.c \
	stress-vecfp.c \
	stress-vecmath.c \
	stress-vecshuf.c \
	stress-vecwide.c \
	stress-verity.c \
	stress-vforkmany.c \
	stress-vm.c \
	stress-vm-addr.c \
	stress-vm-rw.c \
	stress-vm-segv.c \
	stress-vm-splice.c \
	stress-vma.c \
	stress-vnni.c \
	stress-wait.c \
	stress-waitcpu.c \
	stress-watchdog.c \
	stress-wcs.c \
	stress-workload.c \
	stress-x86cpuid.c \
	stress-x86syscall.c \
	stress-xattr.c \
	stress-yield.c \
	stress-zero.c \
	stress-zlib.c \
	stress-zombie.c \


#
#  Build time core source files
#
CORE_SRC_GEN = \
	core-config.c

#
# Stress core
#
CORE_SRC = \
	core-affinity.c \
	core-asm-ret.c \
	core-cpu.c \
	core-cpu-cache.c \
	core-cpuidle.c \
	core-clocksource.c \
	core-config-check.c \
	core-hash.c \
	core-helper.c \
	core-ignite-cpu.c \
	core-interrupts.c \
	core-io-uring.c \
	core-io-priority.c \
	core-job.c \
	core-killpid.c \
	core-klog.c \
	core-limit.c \
	core-lock.c \
	core-log.c \
	core-madvise.c \
	core-mincore.c \
	core-mlock.c \
	core-mmap.c \
	core-module.c \
	core-mounts.c \
	core-mwc.c \
	core-net.c \
	core-numa.c \
	core-opts.c \
	core-out-of-memory.c \
	core-parse-opts.c \
	core-perf.c \
	core-processes.c \
	core-resources.c \
	core-sched.c \
	core-setting.c \
	core-shared-heap.c \
	core-shim.c \
	core-smart.c \
	core-sort.c \

=== debian/changelog ===
stress-ng (0.17.02-1) unstable; urgency=medium

  [Sascha Hauer]
  * stress-physpage: explicitly use 64bit type for physical addresses
  * stress-ng.h: define _FILE_OFFSET_BITS before including features.h

  [Rulin Huang]
  * Reduce the file operations if the unused pid can be found within
    several tries

  [Colin Ian King]
  * stress-bigheap: ensure value in *uintptr is initialized
  * stress-workload: clean up some clang-scan-build warnings
  * stress-workload: remove redundant assignments to variable t
  * stress-workload: remove redundant initialization of t_begin
  * stress-sigpipe: add wrapper to pipe_child to clear up tcc warning
  * stress-reboot: add wrapper to reboot_clone_func to clear up tcc
    warning
  * stress-vma: remove volatile cast, it is unnecessary
  * stress-lsearch: add casts to const char * to avoid void * arithmetic
  * stress-bsearch: cast base to const char * to avoid void * arithmetic
  * core-time: return -1 if time not available via
    stress_time_now_timespec
  * stress-msync: make pointer buf unclobberable
  * stress-msg: remove another invalid msgrcv calls that work for
    OpenBSD systems
  * stress-msg: remove invalid msgrcv calls that work for *BSD systems
  * core-shim: Fix non-PURE shim_enosys function
  * core-resources: include core-pthread.h for pthread types
  * stress-get: don't call gettimeofday with NULL values
  * core-shim/stress-get: use gettimeofday() for non-linux shim_time calls
  * core-shim: fix typo: tlock -> tloc
  * core-shim/stress-get: use time() for non-linux shim_time calls
  * stress-get: fix error messages, replace gettimeval with gettimeofday
  * stress-get: only exercise time(NULL) on Linux
  * core-helper: move ret inside #ifdef block
  * README.md: Update contributor list
  * stress-*: clean up a handful of spelling mistakes
  * stress-stream: unmap in correct idx order
  * README.md: add another link to a research paper
  * stress-prctl: munmap page_anon on error return path
  * stress-seal: unmap buf on error return paths
  * stress-cyclic: unmap latencies mappings on error return
  * stress-zero: unmap read/write buffers on error return paths
  * stress-stream: simplify error unmapping return paths
  * stress-rawdev: fix memory leak on mmap'd buffer on error return path
  * stress-fail: use fail error exit path for non-implemented /dev/full
  * stress-sockmany: fix memory leak on signal handler error return path
  * stress-signest: fix memory leak on signal handler error return path
  * stress-sock: fix memory leak on fork failure error return path
  * stress-sigpipe: fix memory leak on signal handler error return path
  * stress-stackmmap: make stack_sig non-clobberable
  * stress-sigbus: make ptr non-clobberable
  * core-helper: add stress_mmap_populate to mmap with MAP_POPULATE
  * stress-qsort: add missing tab
  * stress-bseach: add -O3 for nonlibc bsearch function
  * stress-waitcpu: add some more nops
  * stress-vm: remove volaile where it's not required, add memory barrier
  * stress-vm: speed up prime-gray-0 and prime-gray-1 by reducing total
    memory read/writes
  * stress-vm: speed up prime-0 and prime-1 by reducing total memory
    read/writes
  * stress-vma: provide different handlers for SIGBUS and SIGSEGV
  * stress-vma: optimize matrics, add cacheline pad and remove volatile
  * stress-vdso: add dummy function call to emulate minimal vdso function
  * stress-udp: don't memset the send buffer on each send
  * stress-trig: replace iterations with macro STRESS_TRIG_LOOPS
  * stress-trig: unroll loops, speed up by ~4.2%
  * stress-memthrash: only report lack of NUMA support with instance 0
  * stress-schedmix: reduce compute overhead on prime number CPU load
  * stress-stack: unroll loop in stress_stack_alloc
  * stress-sockpair: optimize buffer setting and checking
  * stress-sockdiag: move bogo-op count to outside parser loop
  * stress-skiplist: use 8 bits for skip_list_random_level generation
  * stress-skiplist: optimize ln2 operation using clzl
  * stress-sigxfs: optimize counter increment, remove branch
  * stress-sigxfsz: don't make async_sigs volatile
  * core-helper: only declare array buf when it is required
  * core-helper: voidify function argument dumpable
  * core-helper: only declare array buf when it is required
  * core-shim: move include <sys/uio.h> to core-shim.h
  * stress-gpu: move declarations for gpu_freq_sum and gpu_freq_count
  * core-numa: add stress_numa_nodes helper for non-linux builds
  * stress-stream: don't print numa nodes related info for non-linux
    systems
  * core-shim: add missing include of sys/uio.h required for struct iovec
  * stress-mmapfixed: fix array overflow, iterate over only the array
    elements
  * stress-gpu: ensure usec computations are using uint64_t type
  * stress-hsearch: voidify return from stress_get_setting
  * core-helper: use STRESS_MAXIMUM on maximum pid
  * stress-vma: add in extra protection flags and mmap flags for more
    stress
  * stress-vma: add PROT_NONE back
  * stress-vma: ensure page is always mappable
  * stress-ng: move ci counter struct into args and args into stat struct
  * stress-signal: don't use volatile for in-signal handler counter
    increment
  * stress-ring-pipe: replace % operator with compare and set
  * stress-resched: remove need to check for non-mapped yields array
  * README.md: add more research paper links
  * stress-remap: unroll a handful of loops
  * stress-regs: reference registers rather than v variable
  * stress-readahead: unroll some loops
  * stress-randlist: add prefetch to next pointer in list scanning
  * core-mwc: use clz for shift maximization for 8 and 16 bit mwci
    functions
  * core-sort: optimize of powers of 2 size for
    stress_sort_data_int32_shuffle
  * stress-gpu: only report GPU frequency if > 0.0 MHz
  * core-time: optimize get_time_now()
  * stress-procfs: use MAP_POPULATE on mmap to reduce read-fault hit
  * stress-procfs: perform less timeout checks on 1 byte reads and


=== debian/control ===
Source: stress-ng
Rules-Requires-Root: no
Section: devel
Priority: optional
Maintainer: Colin Ian King <colin.i.king@gmail.com>
Standards-Version: 4.6.2
Build-Depends: debhelper (>= 13),
               debhelper-compat (=13),
               zlib1g-dev,
               libbsd-dev,
               libeigen3-dev,
               libgcrypt20-dev,
               libjpeg-dev,
               libmpfr-dev,
               libkeyutils-dev [linux-any],
               libapparmor-dev [linux-any],
               apparmor [linux-any],
               libaio-dev [linux-any],
               libcap-dev [linux-any],
               libsctp-dev [linux-any],
               libipsec-mb-dev [amd64],
               libjudy-dev,
               libatomic1 [linux-any],
               libkmod-dev [linux-any],
               libxxhash-dev,
               libglvnd-dev,
               libgbm-dev [linux-any]
Homepage: https://github.com/ColinIanKing/stress-ng

Package: stress-ng
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: tool to load and stress a computer
 stress-ng can stress various subsystems of a computer.  It can stress load
 CPU, cache, disk, memory, socket and pipe I/O, scheduling and much more.
 stress-ng is a re-write of the original stress tool by Amos Waterland but
 has many additional features such as specifying the number of bogo operations
 to run, execution metrics, a stress verification on memory and compute
 operations and considerably more stress mechanisms.
